#include <utility/GT911.h>
#ifndef _TOUCH_H_
#define _TOUCH_H_

#include <optional>

class Touch
{
public:
    Touch(GT911 TP, uint_fast8_t rotation) : TP{TP}
    {
        TP.SetRotation(rotation);
    }

    std::optional<tp_finger_t> tap()
    {
        if (!TP.available())
        {
            return std::nullopt;
        }

        TP.update();

        if (TP.isFingerUp())
        {
            touching = false;
            return std::nullopt;
        }

        if (touching)
        {
            return std::nullopt;
        }

        touching = true;

        auto f = TP.readFinger(0);
        auto x = 540 - f.y;
        auto y = f.x;

        f.x = x;
        f.y = y;

        return f;
    }

private:
    GT911 TP;
    tp_finger_t finger;
    bool touching;
};

#endif